#include "ending1.hpp"

#include "mathstuff.hpp"
#include "mainpart.hpp"
#include "gamestrings.hpp"

/****************

 THE GOOD ENDING

*****************/


void Ending1::drawCutBars()
{
  glDisable( GL_DEPTH_TEST );
  glDisable( GL_TEXTURE_2D );

  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
  glLoadIdentity();
  glMatrixMode(GL_MODELVIEW);

  glColor4f(0,0,0,1);
  glPushMatrix();
  glLoadIdentity();
  glBegin(GL_QUADS);
  glVertex2f(-1,1);
  glVertex2f(1,1);
  glVertex2f(1,0.8);
  glVertex2f(-1,0.8);

  glVertex2f(-1,-1);
  glVertex2f(1,-1);
  glVertex2f(1,-0.8);
  glVertex2f(-1,-0.8);
  glEnd();
  glPopMatrix();
  glColor3f(1,1,1);

  glMatrixMode(GL_PROJECTION);
  glPopMatrix();
  glMatrixMode(GL_MODELVIEW);

  glEnable( GL_TEXTURE_2D );
  glEnable( GL_DEPTH_TEST );
}

void Ending1::dildodraw()
{

static GLfloat theta=0;
theta+=3;
int dildoselected=-1;
GLfloat curmaxdist=0.5*0.5;

if (state->wife.carrying==-1)
{
for (int i=0;i<3;i++)
{
  GLfloat d=sqlength(state->dildo[i].x-state->wife.pos.x, state->dildo[i].z-state->wife.pos.y);
  if (d<curmaxdist)
  {
    curmaxdist=d;
    dildoselected=i;
  }
}
}

for (int i=0;i<3;i++)
{
  switch (state->dildo[i].state)
  {
    case 0:
      if (dildoselected!=i)
      {
        glPushMatrix();
        glTranslatef(-state->dildo[i].x,-state->dildo[i].y,-state->dildo[i].z);
        glCallList(state->dildo[i].dlist);
        glPopMatrix();
      }
      else {
        glPushMatrix();
        glTranslatef(-state->dildo[i].x,-state->dildo[i].y+0.1,-state->dildo[i].z);
        glRotatef(theta,0,1,0);
        glCallList(state->dildo[i].dlist);
        glPopMatrix();
      }
      break;
    case 1:
      glPushMatrix();
      glTranslatef(-state->wife.pos.x,0.4,-state->wife.pos.y);
      glRotatef(state->wife.angle,0,1,0);
      glTranslatef(0.1,0,0.15);
      if (sqlength(state->boss.pos.x-state->wife.pos.x, state->boss.pos.y-state->wife.pos.y)<curmaxdist)
        glRotatef(theta,0,1,0);
      glCallList(state->dildo[i].dlist);
      glPopMatrix();
      break;
    case 2:
      state->hidecounter+=3.0/40;

      glPushMatrix();
      glTranslatef(-state->dildo[i].x+sin(state->hidecounter)/16,-state->dildo[i].y,-state->dildo[i].z);
      glRotatef(90,0,0,1);
//				glRotatef(theta,0,1,0);
      glCallList(state->dildo[i].dlist);
      glPopMatrix();

      if (state->hidecounter>5*3.1415926535/2)
      {
        state->dildo[i].state=3;
        state->dildo[i].x=-1.2+1.9-0.45;
        state->dildo[i].y=-0.1;
        state->dildo[i].z=-1+0.15*i;
        state->boss.cansee=true;
      }
      break;
    case 3:

      glPushMatrix();
      glTranslatef(-state->dildo[i].x,-state->dildo[i].y,-state->dildo[i].z);
      glRotatef(90,0,0,1);
      glCallList(state->dildo[i].dlist);
      glPopMatrix();
      break;
  }




}
}

void Ending1::reset()
{

  state->boss.onbed=false;


  state->dildo[0].x=0.9;
  state->dildo[0].y=-0.3;
  state->dildo[0].z=-1.4;
  state->dildo[0].state=0;

  state->dildo[1].x=1.3;
  state->dildo[1].y=-0.3;
  state->dildo[1].z=-1.4;
  state->dildo[1].state=0;

  state->dildo[2].x=1.7;
  state->dildo[2].y=-0.3;
  state->dildo[2].z=-1.4;
  state->dildo[2].state=0;


  state->intstate=0;
  state->tx=0;
  state->ty=0;
  state->tz=0;
  state->xrot=0;
  state->yrot=0;
  state->zrot=0;
  state->hidecounter=0;
}

Ending1::Ending1(const SubengineInterface* subengines, Global_Variables* p_global_variables):
EnginePart(subengines),
state(new Ending1_State),
global_variables(p_global_variables)
{
  state->wife.dlist=graphicsengine->models[1]->dlist;
  state->lover.dlist=graphicsengine->models[2]->dlist;
  state->boss.dlist1=graphicsengine->models[3]->dlist;
  state->boss.dlist2=graphicsengine->models[4]->dlist;
  state->dildo[0].dlist=graphicsengine->models[5]->dlist;
  state->dildo[1].dlist=graphicsengine->models[6]->dlist;
  state->dildo[2].dlist=graphicsengine->models[7]->dlist;

  state->wife.dildo=state->dildo;
  state->wife.hidecounter=&state->hidecounter;
  state->boss.fontrenderer=graphicsengine->fontrenderer;


};

Ending1::~Ending1()
{
  delete state;
}

int Ending1::input(const SDL_Event& event)
{
		if( event.type == SDL_KEYDOWN )
    {
      switch( event.key.keysym.sym )
      {
        case SDLK_ESCAPE:
          return 1;
          break;
        case SDLK_SPACE:
        case SDLK_RETURN:
          if (state->intstate<3)
          {
            state->intstate++;
          }
          else
            return 1;
          break;
        default:
            break;
          /*//CAMERA POSITIONING CONTROLS
        case SDLK_q:
          state->tx+=0.1;
          break;
        case SDLK_w:
          state->ty+=0.1;
          break;
        case SDLK_e:
          state->tz+=0.1;
          break;
        case SDLK_a:
          state->tx-=0.1;
          break;
        case SDLK_s:
          state->ty-=0.1;
          break;
        case SDLK_d:
          state->tz-=0.1;
          break;
        case SDLK_r:
          state->xrot+=5;
          break;
        case SDLK_t:
          state->yrot+=5;
          break;
        case SDLK_y:
          state->zrot+=5;
          break;
        case SDLK_f:
          state->xrot-=5;
          break;
        case SDLK_g:
          state->yrot-=5;
          break;
        case SDLK_h:
          state->zrot-=5;
          break;
        case SDLK_p:
          std::cout<<"\n"<<state->tx<<","<<state->ty<<","<<state->tz<<"\n"
              <<state->xrot<<","<<state->yrot<<","<<state->zrot<<"\n";
          break;*/
      }
    }

  return 0;
}

int Ending1::logic()
{

  return 0;
}

void Ending1::draw()
{
 	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

  state->tx=-0.8;
  state->ty=-0.4-0.2;
  state->tz=2.4;

  state->xrot=5;
  state->yrot=0;
  state->zrot=0;

  for (int i=0;i<3;i++)
  {
    if (state->dildo[i].state==0)
    {
      state->dildo[i].state=1;
      state->wife.carrying=i;
    }
  }

   glLoadIdentity( );
      glTranslatef( 0.0f, 0.12f, -4.65f );

      glTranslatef( state->tx, state->ty, state->tz );

      glRotatef( state->xrot, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
      glRotatef( state->yrot, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
      glRotatef( state->zrot, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */

      glCallList(graphicsengine->models[ROOM_MODEL]->dlist);

      state->wife.pos.x=-0.4;
      state->wife.pos.y=-1;
      state->wife.angle=90;
      state->wife.draw();

      if (global_variables->wifecarrying!=-1)
      {
      glPushMatrix();
      glTranslatef(-state->wife.pos.x,0.4,-state->wife.pos.y);
      glRotatef(state->wife.angle,0,1,0);
      glTranslatef(0.1,0,0.15);
      glCallList(state->dildo[global_variables->wifecarrying].dlist);
      glPopMatrix();
      }

      state->boss.pos.x=-1.2;
      state->boss.pos.y=-1;
      state->boss.angle=270;
      state->boss.draw();

  switch (state->intstate)
  {
    case 0:
      break;
    case 1:
      graphicsengine->fontrenderer->glPrint(24, 100,dialogue[29][global_variables->language].c_str(), 0);
      break;
    case 2:
      graphicsengine->fontrenderer->glPrint(425, 100,dialogue[29][global_variables->language].c_str(), 0);
      break;
    case 3:
      break;
  };
  drawCutBars();

}
