#include "mainpart.hpp"
#include "mathstuff.hpp"

Main_State::Main_State()
{

  wife.carrying=-1;

  dildo[0].x=0.9;
  dildo[0].y=-0.3;
  dildo[0].z=-1.4;
  dildo[0].state=0;

  dildo[1].x=1.3;
  dildo[1].y=-0.3;
  dildo[1].z=-1.4;
  dildo[1].state=0;

  dildo[2].x=1.7;
  dildo[2].y=-0.3;
  dildo[2].z=-1.4;
  dildo[2].state=0;

  lover.pos.x=1.75;
  lover.pos.y=0.3;
  lover.angle=0;

  boss.pos.x=-1.2;
  boss.pos.y=-1;
  boss.angle=270;

  wife.pos.x=-0.4;
  wife.pos.y=-1;
  wife.angle=90;


  wife.dildo=dildo;
  wife.hidecounter=&hidecounter;
  wife.boss=&boss;


  boss.onbed=false;
  boss.cansee=true;
  boss.curframe=0;

  tx=0.5;
  ty=-0.6;
  tz=4.9;

}

void MainPart::reset()
{
  delete state;
  state = new Main_State;

  state->wife.dlist=graphicsengine->models[1]->dlist;
  state->lover.dlist=graphicsengine->models[2]->dlist;
  state->boss.dlist1=graphicsengine->models[3]->dlist;
  state->boss.dlist2=graphicsengine->models[4]->dlist;
  state->dildo[0].dlist=graphicsengine->models[5]->dlist;
  state->dildo[1].dlist=graphicsengine->models[6]->dlist;
  state->dildo[2].dlist=graphicsengine->models[7]->dlist;

  state->boss.fontrenderer=graphicsengine->fontrenderer;
  state->boss.language=global_variables->language;
  state->wife.carrying=-1;

  state->dildo[0].x=0.9;
  state->dildo[0].y=-0.3;

  global_variables->wifecarrying=-1;

}

MainPart::MainPart(SubengineInterface* subengines, Global_Variables* p_global_variables):
EnginePart(subengines),
state(new Main_State),
global_variables(p_global_variables)
{
  reset();
};

MainPart::~MainPart()
{
  state = new Main_State;
}

int MainPart::input(const SDL_Event& event)
{
  switch (event.type)
  {
  case SDL_QUIT:
      return -1;
      break;
  case SDL_KEYDOWN:
    {
      switch( event.key.keysym.sym )
      {
      case SDLK_ESCAPE:
				return 3;
				break;
			default:
				break;
      }
    }
  }

	state->wife.input(event);
	state->lover.input(event);


  return 0;
}

int MainPart::logic()
{
	state->wife.move(state->lover.pos.x,state->lover.pos.y,state->boss.pos.x,state->boss.pos.y);
	state->lover.move(state->wife.pos.x,state->wife.pos.y,state->boss.pos.x,state->boss.pos.y);
	state->boss.move(0,0,0,0);
	if (state->boss.cansee && state->lover.visible())
	{
		return 2;
	}
	else if (state->lover.pos.x<-2.2)
	{
    for (int i=0;i<3;i++)
    {
      if (state->dildo[i].state==0)
      {
        global_variables->wifecarrying=i;
      }
    }


    soundengine->streamtrack("audio/2.xm");
		return 1;
	}

  return 0;
}

void MainPart::dildodraw()
{
	static GLfloat theta=0;
	theta+=3;
	int dildoselected=-1;
	GLfloat curmaxdist=0.5*0.5;

	if (state->wife.carrying==-1)
	{
	for (int i=0;i<3;i++)
	{
		GLfloat d=sqlength(state->dildo[i].x-state->wife.pos.x, state->dildo[i].z-state->wife.pos.y);
		if (d<curmaxdist)
		{
			curmaxdist=d;
			dildoselected=i;
		}
	}
	}

	for (int i=0;i<3;i++)
	{
		switch (state->dildo[i].state)
		{
			case 0:
				if (dildoselected!=i)
				{
					glPushMatrix();
					glTranslatef(-state->dildo[i].x,-state->dildo[i].y,-state->dildo[i].z);
          glCallList(state->dildo[i].dlist);
          glPopMatrix();
				}
				else {
					glPushMatrix();
					glTranslatef(-state->dildo[i].x,-state->dildo[i].y+0.1,-state->dildo[i].z);
					glRotatef(theta,0,1,0);
          glCallList(state->dildo[i].dlist);
					glPopMatrix();
				}
				break;
			case 1:
				glPushMatrix();
				glTranslatef(-state->wife.pos.x,0.4,-state->wife.pos.y);
				glRotatef(state->wife.angle,0,1,0);
				glTranslatef(0.1,0,0.15);
				if (sqlength(state->boss.pos.x-state->wife.pos.x, state->boss.pos.y-state->wife.pos.y)<curmaxdist)
					glRotatef(theta,0,1,0);
        glCallList(state->dildo[i].dlist);
				glPopMatrix();
				break;
			case 2:
				state->hidecounter+=3.0/40;

				glPushMatrix();
				glTranslatef(-state->dildo[i].x+sin(state->hidecounter)/16,-state->dildo[i].y,-state->dildo[i].z);
				glRotatef(90,0,0,1);
//				glRotatef(theta,0,1,0);
        glCallList(state->dildo[i].dlist);
				glPopMatrix();

				if (state->hidecounter>5*3.1415926535/2)
				{
					state->dildo[i].state=3;
					state->dildo[i].x=-1.2+1.9-0.45;
					state->dildo[i].y=-0.1;
					state->dildo[i].z=-1+0.15*i;
					state->boss.cansee=true;
				}
				break;
			case 3:

				glPushMatrix();
				glTranslatef(-state->dildo[i].x,-state->dildo[i].y,-state->dildo[i].z);
				glRotatef(90,0,0,1);
        glCallList(state->dildo[i].dlist);

				glPopMatrix();
				break;
		}
	}
}

void MainPart::draw()
{
    /* Move Into The Screen 5 Units */
    glLoadIdentity( );
    glTranslatef( 0.0f, 0.12f, -4.65f );

    glRotatef( 30, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
    glRotatef( 10, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
    glRotatef( 0, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */


        glCallList(graphicsengine->models[ROOM_MODEL]->dlist);

	dildodraw();

	state->wife.draw();
	state->lover.draw();
	state->boss.draw();
}
