#include "cutscene.hpp"

#include "mathstuff.hpp"
#include "mainpart.hpp"
#include "gamestrings.hpp"


void CutScene::drawCutBars()
{
  glDisable( GL_DEPTH_TEST );
  glDisable( GL_TEXTURE_2D );

  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
  glLoadIdentity();
  glMatrixMode(GL_MODELVIEW);

  glColor4f(0,0,0,1);
  glPushMatrix();
  glLoadIdentity();
  glBegin(GL_QUADS);
  glVertex2f(-1,1);
  glVertex2f(1,1);
  glVertex2f(1,0.8);
  glVertex2f(-1,0.8);

  glVertex2f(-1,-1);
  glVertex2f(1,-1);
  glVertex2f(1,-0.8);
  glVertex2f(-1,-0.8);
  glEnd();
  glPopMatrix();
  glColor3f(1,1,1);

  glMatrixMode(GL_PROJECTION);
  glPopMatrix();
  glMatrixMode(GL_MODELVIEW);

  glEnable( GL_TEXTURE_2D );
  glEnable( GL_DEPTH_TEST );
}

void CutScene::dildodraw()
{

static GLfloat theta=0;
theta+=3;
int dildoselected=-1;
GLfloat curmaxdist=0.5*0.5;

if (state->wife.carrying==-1)
{
for (int i=0;i<3;i++)
{
  GLfloat d=sqlength(state->dildo[i].x-state->wife.pos.x, state->dildo[i].z-state->wife.pos.y);
  if (d<curmaxdist)
  {
    curmaxdist=d;
    dildoselected=i;
  }
}
}

for (int i=0;i<3;i++)
{
  switch (state->dildo[i].state)
  {
    case 0:
      if (dildoselected!=i)
      {
        glPushMatrix();
        glTranslatef(-state->dildo[i].x,-state->dildo[i].y,-state->dildo[i].z);
        glCallList(state->dildo[i].dlist);
        glPopMatrix();
      }
      else {
        glPushMatrix();
        glTranslatef(-state->dildo[i].x,-state->dildo[i].y+0.1,-state->dildo[i].z);
        glRotatef(theta,0,1,0);
        glCallList(state->dildo[i].dlist);
        glPopMatrix();
      }
      break;
    case 1:
      glPushMatrix();
      glTranslatef(-state->wife.pos.x,0.4,-state->wife.pos.y);
      glRotatef(state->wife.angle,0,1,0);
      glTranslatef(0.1,0,0.15);
      if (sqlength(state->boss.pos.x-state->wife.pos.x, state->boss.pos.y-state->wife.pos.y)<curmaxdist)
        glRotatef(theta,0,1,0);
      glCallList(state->dildo[i].dlist);
      glPopMatrix();
      break;
    case 2:
      state->hidecounter+=3.0/40;

      glPushMatrix();
      glTranslatef(-state->dildo[i].x+sin(state->hidecounter)/16,-state->dildo[i].y,-state->dildo[i].z);
      glRotatef(90,0,0,1);
//				glRotatef(theta,0,1,0);
      glCallList(state->dildo[i].dlist);
      glPopMatrix();

      if (state->hidecounter>5*3.1415926535/2)
      {
        state->dildo[i].state=3;
        state->dildo[i].x=-1.2+1.9-0.45;
        state->dildo[i].y=-0.1;
        state->dildo[i].z=-1+0.15*i;
        state->boss.cansee=true;
      }
      break;
    case 3:

      glPushMatrix();
      glTranslatef(-state->dildo[i].x,-state->dildo[i].y,-state->dildo[i].z);
      glRotatef(90,0,0,1);
      glCallList(state->dildo[i].dlist);
      glPopMatrix();
      break;
  }




}
}

void CutScene::reset()
{
  state->boss.onbed=false;

  state->dildo[0].x=0.9;
  state->dildo[0].y=-0.3;
  state->dildo[0].z=-1.4;
  state->dildo[0].state=0;

  state->dildo[1].x=1.3;
  state->dildo[1].y=-0.3;
  state->dildo[1].z=-1.4;
  state->dildo[1].state=0;

  state->dildo[2].x=1.7;
  state->dildo[2].y=-0.3;
  state->dildo[2].z=-1.4;
  state->dildo[2].state=0;


  state->intstate=0;
  state->tx=0;
  state->ty=0;
  state->tz=0;
  state->xrot=0;
  state->yrot=0;
  state->zrot=0;
  state->hidecounter=0;
}

CutScene::CutScene(const SubengineInterface* subengines, Global_Variables* p_global_variables):
EnginePart(subengines),
state(new CutScene_State),
global_variables(p_global_variables)
{
  state->wife.dlist=graphicsengine->models[1]->dlist;
  state->lover.dlist=graphicsengine->models[2]->dlist;
  state->boss.dlist1=graphicsengine->models[3]->dlist;
  state->boss.dlist2=graphicsengine->models[4]->dlist;
  state->dildo[0].dlist=graphicsengine->models[5]->dlist;
  state->dildo[1].dlist=graphicsengine->models[6]->dlist;
  state->dildo[2].dlist=graphicsengine->models[7]->dlist;

  state->wife.dildo=state->dildo;
  state->wife.hidecounter=&state->hidecounter;
  state->boss.fontrenderer=graphicsengine->fontrenderer;

};

CutScene::~CutScene()
{
  delete state;
}

void CutScene::setCamera()
{
switch (state->intstate)
{
  case 0:
    break;
  case 1:
    break;
  case 2:
    state->tx=0.9;
    state->ty=-0.6;
    state->tz=3.6;

    state->xrot=10;
    state->yrot=-60;
    state->zrot=5;
    break;
  case 3:
    break;
  case 4:
    break;
  case 5:
    /*
    state->tx=-0.7;
    state->ty=-0.7;
    state->tz=2.8;

    state->xrot=5;
    state->yrot=40;
    state->zrot=5;*/

    state->tx=-0.4;
    state->ty=-0.6;
    state->tz=2.8;

    state->xrot=5;
    state->yrot=40;
    state->zrot=20;
    break;
  case 6:
    state->tx=1;
    state->ty=-0.7;
    state->tz=4.3;

    state->xrot=5;
    state->yrot=-90;
    state->zrot=0;
    break;
  case 7:
    state->tx=-0.5;
    state->ty=-0.6;
    state->tz=2.8;

    state->xrot=5;
    state->yrot=35;
    state->zrot=5;
    break;
  case 8:
    soundengine->play(2);
    state->tx=-0.6;
    state->ty=-0.85;
    state->tz=3.5;

    state->xrot=5;
    state->yrot=30;
    state->zrot=20;
    break;
  case 9:
    break;
  case 10:
    state->tx=0.1;
    state->ty=-0.45;
    state->tz=2.3;

    state->xrot=15;
    state->yrot=-25;
    state->zrot=-5;
    break;
  case 11:
    state->tx=0;
    state->ty=-0.25;
    state->tz=2.1;

    state->xrot=20;
    state->yrot=-60;
    state->zrot=-5;
    break;
  case 12:
    state->tx=0;
    state->ty=-0.25;
    state->tz=2.1;

    state->xrot=20;
    state->yrot=-60;
    state->zrot=-5;
    break;
  case 13:
    state->tx=-0.6;
    state->ty=-0.15;
    state->tz=1.9;

    state->xrot=10;
    state->yrot=60;
    state->zrot=0;
    break;
  case 14:
    state->tx=-0.6;
    state->ty=-0.15;
    state->tz=1.9;

    state->xrot=10;
    state->yrot=60;
    state->zrot=0;
    break;
  case 15:
    state->tx=-0.6;
    state->ty=-0.15;
    state->tz=1.9;

    state->xrot=10;
    state->yrot=60;
    state->zrot=0;
    break;
  case 16:
    state->tx=0.1;
    state->ty=-0.45;
    state->tz=2.3;

    state->xrot=15;
    state->yrot=-25;
    state->zrot=-5;
    break;
  case 17:
    state->tx=-1.2;
    state->ty=-0.25;
    state->tz=2.7;

    state->xrot=15;
    state->yrot=35;
    state->zrot=-10;
    break;
  case 18:
    state->tx=0.1;
    state->ty=-0.45;
    state->tz=2.3;

    state->xrot=15;
    state->yrot=-25;
    state->zrot=-5;
    break;
  case 19:
    state->tx=0.1;
    state->ty=-0.45;
    state->tz=2.3;

    state->xrot=15;
    state->yrot=-25;
    state->zrot=-5;
    break;
  default:
    break;
}
}

int CutScene::input(const SDL_Event& event)
{
		if( event.type == SDL_KEYDOWN )
    {
      switch( event.key.keysym.sym )
      {
        case SDLK_ESCAPE:
          return 1;
          break;
        case SDLK_SPACE:
        case SDLK_RETURN:
          if (state->intstate<18)
          {
            state->intstate++;
            setCamera();
          }
          else
            return 1;
          break;
        default:
            break;
          /*//CAMERA POSITIONING CONTROLS
        case SDLK_q:
          state->tx+=0.1;
          break;
        case SDLK_w:
          state->ty+=0.1;
          break;
        case SDLK_e:
          state->tz+=0.1;
          break;
        case SDLK_a:
          state->tx-=0.1;
          break;
        case SDLK_s:
          state->ty-=0.1;
          break;
        case SDLK_d:
          state->tz-=0.1;
          break;
        case SDLK_r:
          state->xrot+=5;
          break;
        case SDLK_t:
          state->yrot+=5;
          break;
        case SDLK_y:
          state->zrot+=5;
          break;
        case SDLK_f:
          state->xrot-=5;
          break;
        case SDLK_g:
          state->yrot-=5;
          break;
        case SDLK_h:
          state->zrot-=5;
          break;
        case SDLK_p:
          std::cout<<"\n"<<state->tx<<","<<state->ty<<","<<state->tz<<"\n"
              <<state->xrot<<","<<state->yrot<<","<<state->zrot<<"\n";
          break;*/
      }
    }

  return 0;
}

int CutScene::logic()
{

  return 0;
}

void CutScene::draw()
{
	switch (state->intstate)
		{
			case 0:
				graphicsengine->fontrenderer->glPrint(100, 100,dialogue[0][global_variables->language].c_str(), 0);
				break;
			case 1:
				graphicsengine->fontrenderer->glPrint(100, 200,dialogue[1][global_variables->language].c_str(), 0);
				break;
			case 2:
				glLoadIdentity( );
				glTranslatef( 0.0f, 0.12f, -4.65f );

				glTranslatef( state->tx, state->ty, state->tz );

				glRotatef( state->xrot, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
				glRotatef( state->yrot, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
				glRotatef( state->zrot, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */

				state->lover.pos.x=0.3;
				state->lover.pos.y=-1;
				state->lover.angle=90;
        glCallList(graphicsengine->models[ROOM_MODEL]->dlist);
				dildodraw();
				state->lover.draw();
				break;
			case 3:
				glLoadIdentity( );
				glTranslatef( 0.0f, 0.12f, -4.65f );

				glTranslatef(state->tx, state->ty, state->tz );

				glRotatef(  state->xrot, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
				glRotatef(  state->yrot, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
				glRotatef(  state->zrot, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */

				state->lover.pos.x=0.3;
				state->lover.pos.y=-1;
				state->lover.angle=90;
        glCallList(graphicsengine->models[ROOM_MODEL]->dlist);
				dildodraw();
				state->lover.draw();
				graphicsengine->fontrenderer->glPrint(100, 60,dialogue[2][global_variables->language].c_str(), 0);
				break;
			case 4:
				glLoadIdentity( );
				glTranslatef( 0.0f, 0.12f, -4.65f );

				glTranslatef( state->tx, state->ty, state->tz );

				glRotatef( state->xrot, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
				glRotatef( state->yrot, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
				glRotatef( state->zrot, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */

				state->lover.pos.x=0.3;
				state->lover.pos.y=-1;
				state->lover.angle=90;
        glCallList(graphicsengine->models[ROOM_MODEL]->dlist);
				dildodraw();
				state->lover.draw();
				graphicsengine->fontrenderer->glPrint(100, 190,dialogue[3][global_variables->language].c_str(), 0);
				break;
			case 5:
				glLoadIdentity( );
				glTranslatef( 0.0f, 0.12f, -4.65f );

				glTranslatef( state->tx, state->ty, state->tz );

				glRotatef( state->xrot, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
				glRotatef( state->yrot, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
				glRotatef( state->zrot, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */

        glCallList(graphicsengine->models[ROOM_MODEL]->dlist);
				dildodraw();


				state->wife.pos.x=-0.4;
				state->wife.pos.y=-1;
				state->wife.angle=-90;
				state->wife.draw();

				state->lover.pos.x=0.3;
				state->lover.pos.y=-1;
				state->lover.angle=90;
				state->lover.draw();


				graphicsengine->fontrenderer->glPrint(100, 100,dialogue[4][global_variables->language].c_str(), 0);
				break;
			case 6:
				glLoadIdentity( );
				glTranslatef( 0.0f, 0.12f, -4.65f );

				glTranslatef( state->tx, state->ty, state->tz );

				glRotatef( state->xrot, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
				glRotatef( state->yrot, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
				glRotatef( state->zrot, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */

        glCallList(graphicsengine->models[ROOM_MODEL]->dlist);
				dildodraw();

				state->lover.pos.x=0.3;
				state->lover.pos.y=-1;
				state->lover.angle=90;
				state->lover.draw();

				graphicsengine->fontrenderer->glPrint(50, 120,dialogue[5][global_variables->language].c_str(), 0);
				break;
			case 7:
				glLoadIdentity( );
				glTranslatef( 0.0f, 0.12f, -4.65f );

				glTranslatef( state->tx, state->ty, state->tz );

				glRotatef( state->xrot, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
				glRotatef( state->yrot, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
				glRotatef( state->zrot, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */

        glCallList(graphicsengine->models[ROOM_MODEL]->dlist);
				dildodraw();


				state->wife.pos.x=-0.4;
				state->wife.pos.y=-1;
				state->wife.angle=-90;
				state->wife.draw();

				state->lover.pos.x=0.3;
				state->lover.pos.y=-1;
				state->lover.angle=90;
				state->lover.draw();

				graphicsengine->fontrenderer->glPrint(150, 100,dialogue[6][global_variables->language].c_str(), 0);
				break;
			case 8:
				glLoadIdentity( );
				glTranslatef( 0.0f, 0.12f, -4.65f );

				glTranslatef( state->tx, state->ty, state->tz );

				glRotatef( state->xrot, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
				glRotatef( state->yrot, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
				glRotatef( state->zrot, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */

        glCallList(graphicsengine->models[ROOM_MODEL]->dlist);
				dildodraw();


				state->wife.pos.x=-0.4;
				state->wife.pos.y=-1;
				state->wife.angle=-90;
				state->wife.draw();

				state->lover.pos.x=0.3;
				state->lover.pos.y=-1;
				state->lover.angle=90;
				state->lover.draw();

				graphicsengine->fontrenderer->glPrint(100, 100,dialogue[7][global_variables->language].c_str(), 0);
				break;
			case 9:
				glLoadIdentity( );
				glTranslatef( 0.0f, 0.12f, -4.65f );

				glTranslatef( state->tx, state->ty, state->tz );

				glRotatef( state->xrot, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
				glRotatef( state->yrot, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
				glRotatef( state->zrot, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */

        glCallList(graphicsengine->models[ROOM_MODEL]->dlist);
				dildodraw();


				state->wife.pos.x=-0.4;
				state->wife.pos.y=-1;
				state->wife.angle=-90;
				state->wife.draw();

				state->lover.pos.x=0.3;
				state->lover.pos.y=-1;
				state->lover.angle=90;
				state->lover.draw();

				graphicsengine->fontrenderer->glPrint(50, 200,dialogue[8][global_variables->language].c_str(), 0);
				break;
			case 10:
				glLoadIdentity( );
				glTranslatef( 0.0f, 0.12f, -4.65f );

				glTranslatef( state->tx, state->ty, state->tz );

				glRotatef( state->xrot, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
				glRotatef( state->yrot, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
				glRotatef( state->zrot, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */

        glCallList(graphicsengine->models[ROOM_MODEL]->dlist);
				dildodraw();


				state->wife.pos.x=-0.4;
				state->wife.pos.y=-1;
				state->wife.angle=-90;
				state->wife.draw();

				state->lover.pos.x=0.3;
				state->lover.pos.y=-0.2;
				state->lover.angle=-120;
				state->lover.draw();

				graphicsengine->fontrenderer->glPrint(10, 100,dialogue[9][global_variables->language].c_str(), 0);
				break;
			case 11:
				glLoadIdentity( );
				glTranslatef( 0.0f, 0.12f, -4.65f );

				glTranslatef( state->tx, state->ty, state->tz );

				glRotatef( state->xrot, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
				glRotatef( state->yrot, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
				glRotatef( state->zrot, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */

        glCallList(graphicsengine->models[ROOM_MODEL]->dlist);
				dildodraw();


				state->wife.pos.x=-0.4;
				state->wife.pos.y=-1;
				state->wife.angle=90;
				state->wife.draw();

				state->lover.pos.x=1.75;
				state->lover.pos.y=0.3;
				state->lover.angle=0;
				state->lover.draw();


				state->boss.pos.x=-1.2;
				state->boss.pos.y=-1;
				state->boss.angle=270;
				state->boss.draw();

				break;
			case 12:
				glLoadIdentity( );
				glTranslatef( 0.0f, 0.12f, -4.65f );

				glTranslatef( state->tx, state->ty, state->tz );

				glRotatef( state->xrot, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
				glRotatef( state->yrot, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
				glRotatef( state->zrot, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */

        glCallList(graphicsengine->models[ROOM_MODEL]->dlist);
				dildodraw();


				state->wife.pos.x=-0.4;
				state->wife.pos.y=-1;
				state->wife.angle=90;
				state->wife.draw();

				state->lover.draw();


				state->boss.pos.x=-1.2;
				state->boss.pos.y=-1;
				state->boss.angle=270;
				state->boss.draw();

				graphicsengine->fontrenderer->glPrint(0, 100,dialogue[10][global_variables->language].c_str(), 0);
				break;

			case 13:
				glLoadIdentity( );
				glTranslatef( 0.0f, 0.12f, -4.65f );

				glTranslatef( state->tx, state->ty, state->tz );

				glRotatef( state->xrot, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
				glRotatef( state->yrot, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
				glRotatef( state->zrot, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */

        glCallList(graphicsengine->models[ROOM_MODEL]->dlist);
				dildodraw();


				state->wife.pos.x=-0.4;
				state->wife.pos.y=-1;
				state->wife.angle=90;
				state->wife.draw();

				state->lover.draw();


				state->boss.pos.x=-1.2;
				state->boss.pos.y=-1;
				state->boss.angle=270;
				state->boss.draw();

				break;
			case 14:
				glLoadIdentity( );
				glTranslatef( 0.0f, 0.12f, -4.65f );

				glTranslatef( state->tx, state->ty, state->tz );

				glRotatef( state->xrot, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
				glRotatef( state->yrot, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
				glRotatef( state->zrot, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */

        glCallList(graphicsengine->models[ROOM_MODEL]->dlist);
				dildodraw();


				state->wife.pos.x=-0.4;
				state->wife.pos.y=-1;
				state->wife.angle=90;
				state->wife.draw();

				state->lover.draw();


				state->boss.pos.x=-1.2;
				state->boss.pos.y=-1;
				state->boss.angle=270;
				state->boss.draw();

				graphicsengine->fontrenderer->glPrint(10, 100,dialogue[11][global_variables->language].c_str(), 0);
				break;
			case 15:
				glLoadIdentity( );
				glTranslatef( 0.0f, 0.12f, -4.65f );

				glTranslatef( state->tx, state->ty, state->tz );

				glRotatef( state->xrot, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
				glRotatef( state->yrot, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
				glRotatef( state->zrot, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */

        glCallList(graphicsengine->models[ROOM_MODEL]->dlist);
				dildodraw();


				state->wife.pos.x=-0.4;
				state->wife.pos.y=-1;
				state->wife.angle=90;
				state->wife.draw();

				state->lover.draw();
				state->boss.pos.x=-1.2;
				state->boss.pos.y=-1;
				state->boss.angle=270;

				state->boss.pos.x=-1.2;
				state->boss.pos.y=-1;
				state->boss.angle=270;
				state->boss.draw();

				graphicsengine->fontrenderer->glPrint(400, 100,dialogue[12][global_variables->language].c_str(), 0);
				break;
			case 16:
				glLoadIdentity( );
				glTranslatef( 0.0f, 0.12f, -4.65f );

				glTranslatef( state->tx, state->ty, state->tz );

				glRotatef( state->xrot, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
				glRotatef( state->yrot, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
				glRotatef( state->zrot, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */

        glCallList(graphicsengine->models[ROOM_MODEL]->dlist);
				dildodraw();

				state->wife.pos.x=-0.4;
				state->wife.pos.y=-1;
				state->wife.angle=90;
				state->wife.draw();

				state->lover.draw();

				state->boss.pos.x=-1.2;
				state->boss.pos.y=-1;
				state->boss.angle=270;
				state->boss.draw();

				graphicsengine->fontrenderer->glPrint(0, 100,dialogue[13][global_variables->language].c_str(), 0);
				break;
			case 17:
				glLoadIdentity( );
				glTranslatef( 0.0f, 0.12f, -4.65f );

				glTranslatef( state->tx, state->ty, state->tz );

				glRotatef( state->xrot, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
				glRotatef( state->yrot, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
				glRotatef( state->zrot, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */

        glCallList(graphicsengine->models[ROOM_MODEL]->dlist);
				dildodraw();

				state->wife.pos.x=-0.4;
				state->wife.pos.y=-1;
				state->wife.angle=90;
				state->wife.draw();

				state->lover.draw();


				state->boss.pos.x=-1.2;
				state->boss.pos.y=-1;
				state->boss.angle=270;
				state->boss.draw();

				graphicsengine->fontrenderer->glPrint(10, 100,dialogue[14][global_variables->language].c_str(), 0);
				break;
			case 18:
				glLoadIdentity( );
				glTranslatef( 0.0f, 0.12f, -4.65f );

				glTranslatef( state->tx, state->ty, state->tz );

				glRotatef( state->xrot, 1.0f, 0.0f, 0.0f); /* Rotate On The X Axis */
				glRotatef( state->yrot, 0.0f, 1.0f, 0.0f); /* Rotate On The Y Axis */
				glRotatef( state->zrot, 0.0f, 0.0f, 1.0f); /* Rotate On The Z Axis */

        glCallList(graphicsengine->models[ROOM_MODEL]->dlist);
				dildodraw();

				state->wife.pos.x=-0.4;
				state->wife.pos.y=-1;
				state->wife.angle=90;
				state->wife.draw();

				state->lover.draw();


				state->boss.pos.x=-1.2;
				state->boss.pos.y=-1;
				state->boss.angle=270;
				state->boss.draw();

				graphicsengine->fontrenderer->glPrint(10, 100,dialogue[15][global_variables->language].c_str(), 0);
				break;
		}
    drawCutBars();
}
